Loading...
Searching...
No Matches
Opm::BinaryCoeff::Brine_CO2< Scalar, H2O, CO2, verbose > Class Template Reference

Binary coefficients for brine and CO2. More...

`#include <Brine_CO2.hpp>`

## Static Public Member Functions

template<class Evaluation, class CO2Params>
static OPM_HOST_DEVICE Evaluation | gasDiffCoeff (const CO2Params &params, const Evaluation &temperature, const Evaluation &pressure, bool extrapolate=false)
| Binary diffusion coefficent [m^2/s] of water in the CO2 phase.
template<class Evaluation>
static OPM_HOST_DEVICE Evaluation | liquidDiffCoeff (const Evaluation &, const Evaluation &)
| Binary diffusion coefficent [m^2/s] of CO2 in the brine phase.
template<class Evaluation, class CO2Params>
static OPM_HOST_DEVICE void | calculateMoleFractions (const CO2Params &params, const Evaluation &temperature, const Evaluation &pg, const Evaluation &salinity, const int knownPhaseIdx, Evaluation &xlCO2, Evaluation &ygH2O, const int &activityModel, bool extrapolate=false)
| Returns the mol (!) fraction of CO2 in the liquid phase and the mol_ (!) fraction of H2O in the gas phase for a given temperature, pressure, CO2 density and brine salinity.
template<class Evaluation>
static Evaluation | henry (const Evaluation &temperature, bool extrapolate=false)
| Henry coefficent for CO2 in brine.
template<class Evaluation, class CO2Params>
static Evaluation | fugacityCoefficientCO2 (const CO2Params &params, const Evaluation &temperature, const Evaluation &pg, const Evaluation &yH2O, const bool highTemp, bool extrapolate=false, bool spycherPruess2005=false)
| Returns the fugacity coefficient of the CO2 component in a water-CO2 mixture.
template<class Evaluation, class CO2Params>
static Evaluation | fugacityCoefficientH2O (const CO2Params &params, const Evaluation &temperature, const Evaluation &pg, const Evaluation &yH2O, const bool highTemp, bool extrapolate=false, bool spycherPruess2005=false)
| Returns the fugacity coefficient of the H2O component in a water-CO2 mixture.

## Detailed Description

template<class Scalar, class H2O, class CO2, bool verbose = true>
class Opm::BinaryCoeff::Brine_CO2< Scalar, H2O, CO2, verbose >

Binary coefficients for brine and CO2.

## Member Function Documentation

## calculateMoleFractions()

template<class Scalar, class H2O, class CO2, bool verbose = true>
template<class Evaluation, class CO2Params>

OPM_HOST_DEVICE void Opm::BinaryCoeff::Brine_CO2< Scalar, H2O, CO2, verbose >::calculateMoleFractions | ( | const CO2Params & | params,
|  | const Evaluation & | temperature,
|  | const Evaluation & | pg,
|  | const Evaluation & | salinity,
|  | const int | knownPhaseIdx,
|  | Evaluation & | xlCO2,
|  | Evaluation & | ygH2O,
|  | const int & | activityModel,
|  | bool | extrapolate = false )

inline static

Returns the mol (!) fraction of CO2 in the liquid phase and the mol_ (!) fraction of H2O in the gas phase for a given temperature, pressure, CO2 density and brine salinity.

Implemented according to "Spycher and Pruess 2005" applying the activity coefficient expression of "Duan and Sun 2003" and the correlations for pure water given in "Spycher, Pruess and Ennis-King 2003"

Parameters

  params | Parameters to use
  temperature | the temperature [K]
  pg | the gas phase pressure [Pa]
  salinity | the salinity [kg NaCl / kg solution]
  knownPhaseIdx | indicates which phases are present
  xlCO2 | mole fraction of CO2 in brine [mol/mol]
  ygH2O | mole fraction of water in the gas phase [mol/mol]
  activityModel | Activity model to use
  extrapolate | True to use extrapolation

## fugacityCoefficientCO2()

template<class Scalar, class H2O, class CO2, bool verbose = true>
template<class Evaluation, class CO2Params>

Evaluation Opm::BinaryCoeff::Brine_CO2< Scalar, H2O, CO2, verbose >::fugacityCoefficientCO2 | ( | const CO2Params & | params,
|  | const Evaluation & | temperature,
|  | const Evaluation & | pg,
|  | const Evaluation & | yH2O,
|  | const bool | highTemp,
|  | bool | extrapolate = false,
|  | bool | spycherPruess2005 = false )

inline static

Returns the fugacity coefficient of the CO2 component in a water-CO2 mixture.

(given in Spycher, Pruess and Ennis-King (2003))

Parameters

  params | Parameters to use
  temperature | the temperature [K]
  pg | the gas phase pressure [Pa]
  yH2O | mole fraction of water
  highTemp | True to use high temperature
  extrapolate | True to use extrapolation
  spycherPruess2005 | True to Spycher-Pruess (2005) model

## fugacityCoefficientH2O()

template<class Scalar, class H2O, class CO2, bool verbose = true>
template<class Evaluation, class CO2Params>

Evaluation Opm::BinaryCoeff::Brine_CO2< Scalar, H2O, CO2, verbose >::fugacityCoefficientH2O | ( | const CO2Params & | params,
|  | const Evaluation & | temperature,
|  | const Evaluation & | pg,
|  | const Evaluation & | yH2O,
|  | const bool | highTemp,
|  | bool | extrapolate = false,
|  | bool | spycherPruess2005 = false )

inline static

Returns the fugacity coefficient of the H2O component in a water-CO2 mixture.

(given in Spycher, Pruess and Ennis-King (2003))

Parameters

  params | Parameters to use
  temperature | the temperature [K]
  pg | the gas phase pressure [Pa]
  yH2O | mole fraction of water
  highTemp | True to use high temperature
  extrapolate | True to use extrapolation
  spycherPruess2005 | True to Spycher-Pruess (2005) model

## gasDiffCoeff()

template<class Scalar, class H2O, class CO2, bool verbose = true>
template<class Evaluation, class CO2Params>

OPM_HOST_DEVICE Evaluation Opm::BinaryCoeff::Brine_CO2< Scalar, H2O, CO2, verbose >::gasDiffCoeff | ( | const CO2Params & | params,
|  | const Evaluation & | temperature,
|  | const Evaluation & | pressure,
|  | bool | extrapolate = false )

inline static

Binary diffusion coefficent [m^2/s] of water in the CO2 phase.

According to "Diffusion of Water in Liquid and Supercritical Carbon Dioxide: An NMR Study",Bin Xu et al., 2002

Parameters

  params | Parameters to use
  temperature | the temperature [K]
  pressure | the phase pressure [Pa]
  extrapolate | True to use extrapolation

## liquidDiffCoeff()

template<class Scalar, class H2O, class CO2, bool verbose = true>
template<class Evaluation>

OPM_HOST_DEVICE Evaluation Opm::BinaryCoeff::Brine_CO2< Scalar, H2O, CO2, verbose >::liquidDiffCoeff | ( | const Evaluation & | ,
|  | const Evaluation & | )

inline static

Binary diffusion coefficent [m^2/s] of CO2 in the brine phase.

Parameters

  temperature | the temperature [K]
  pressure | the phase pressure [Pa]

The documentation for this class was generated from the following file:

- opm/material/binarycoefficients/Brine_CO2.hpp